unit U_DJBCKInPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit,
  ComCtrls, ToolWin, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient, cxButtonEdit,
  cxTextEdit;

type
  TfrmDJBCKInPut = class(TForm)
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column2: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    v1Column4: TcxGridDBColumn;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    v1Column12: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    v1Column18: TcxGridDBColumn;
    v1Column19: TcxGridDBColumn;
    v1Column20: TcxGridDBColumn;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column14PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column1PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column5PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column11PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column16PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column13PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column18PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
  private
    { Private declarations }
    function SaveCKData():Boolean;
    function YSData(Order_Main10:TClientDataSet):Boolean;
    function YFData1():Boolean;
  public
    { Public declarations }
    FBCId:String;
  end;

var
  frmDJBCKInPut: TfrmDJBCKInPut;

implementation
uses
  U_DataLink,U_RTFun,U_ClothContractListHZCX,U_ZDYHelp, U_ZdyAttachGYS,U_ProductOrderListSel,
  U_ProductOrderListSel1;

{$R *.dfm}


function TfrmDJBCKInPut.YSData(Order_Main10:TClientDataSet):Boolean;
var
  CRID,YFID,PriceUnit,OrderUnit,FComTaiTou,FromSubID,khName:String;
  fprice,huilv:double;
begin
  Result:=False;
  fprice:=0;
  huilv:=0;
  PriceUnit:='RMB';
  khName:='';
  with ADOQueryTemp do
  begin
    Close;
    SQL.Clear;
    sql.Add('update JYOrder_Sub SET Huilv=isnull((select Huilv from JYOrderCon_Sub X where X.SubId=JYOrder_Sub.SOrddefstr10),1) where Huilv=0');
    execsql;
  end;
  with Order_Main10 do
  begin
    begin
      with ADOQueryTemp do
      begin
        Close;
        SQL.Clear;
        sql.Add('select A.*,fPrice=dbo.F_Get_Order_Price(A.MainID,A.subID),B.customerNoName');
        sql.Add(' from JYOrder_Sub A  ');
        sql.Add(' inner join  JYOrder_main B on B.mainID=A.mainID  ');
        sql.Add(' Where subID='''+Trim(Order_Main10.fieldbyname('ORDSubIdRK').AsString)+'''');
        Open;
      end;
      IF not ADOQueryTemp.IsEmpty then
      begin
        PriceUnit:=Trim(ADOQueryTemp.fieldbyname('PriceUnit').AsString);
        OrderUnit:=Trim(ADOQueryTemp.fieldbyname('OrderUnit').AsString);
        fPrice:= ADOQueryTemp.fieldbyname('fPrice').AsFloat;
        huilv:= ADOQueryTemp.fieldbyname('huilv').AsFloat;
        khName:= ADOQueryTemp.fieldbyname('customerNoName').AsString;
      end;
      IF huilv=0 then huilv:=1;
      CRID:='0';
      with ADOQueryTemp do
      begin
        Close;
        sql.Clear;
        sql.Add(' select * from YF_Money_CR ');
        sql.Add(' where mainID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
        sql.Add(' and YFName=''客户退货'' ');
        Open;
      end;
      if ADOQueryTemp.IsEmpty then
      begin
        if GetLSNo(ADOQueryCmd,YFID,'CS','YF_Money_CR',3,1)=False then
        begin
          Application.MessageBox('取成品应收最大号失败!','提示',0);
          Exit;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from YF_Money_CR where 1<>1');
          Open;
        end;
        with ADOQueryCmd do
        begin
          Append;
          FieldByName('YFID').Value:=Trim(YFID);
          FieldByName('YFTypeId').Value:=Trim(Order_Main10.fieldbyname('SPID').AsString);
          FieldByName('CRID').Value:=StrToInt(CRID);
          FieldByName('Filler').Value:=Trim(DName);
          FieldByName('CRType').Value:='应收款登记';
          FieldByName('CRFlag').Value:='应收收';
          FieldByName('QtyFlag').Value:=1;
          FieldByName('FactoryName').Value:=Trim(KHName);
          FieldByName('CRTime').Value:=Trim(FormatDateTime('yyyy-MM-dd',CDS_Sub.fieldbyname('CRTime').AsDateTime));
          FieldByName('YFType').Value:='自动生成';
          FieldByName('ps').Value:=-1*Order_Main10.fieldbyname('PiQty').AsFloat;
          FieldByName('Qty').Value:=-1*Order_Main10.fieldbyname('Qty').AsFloat;
          FieldByName('Price').Value:=fprice;
          FieldByName('HuiLv').Value:=huilv;
          FieldByName('BZType').Value:=Trim(PriceUnit);
         // FieldByName('Money').Value:=-1*format('%.2f',[Order_Main10.fieldbyname('Qty').AsFloat*fprice]);
         // FieldByName('BBMoney').Value:=-1*format('%.2f',[Order_Main10.fieldbyname('Qty').AsFloat*fprice*huilv]);
          FieldByName('QtyUnit').Value:=Trim(Order_Main10.fieldbyname('QtyUnit').AsString);
          FieldByName('ComTaiTou').Value:=Trim(KHName);
          FieldByName('YFName').Value:='客户退货';
          FieldByName('MainId').Value:=Trim(Order_Main10.fieldbyname('SPID').AsString);
          FieldByName('subID').Value:='';
          FieldByName('OrderNO').Value:=Trim(Order_Main10.fieldbyname('OrderNO').AsString);
          FieldByName('P_CodeName').Value:=Trim(Order_Main10.fieldbyname('SPName').AsString);
          FieldByName('P_Spec').Value:=Trim(Order_Main10.fieldbyname('SPSpec').AsString);
          FieldByName('P_color').Value:=Trim(Order_Main10.fieldbyname('SPColor').AsString);
          FieldByName('status').Value:='0';
          Post;
        end;
      end
      else
      begin
        YFID:=Trim(ADOQueryTemp.fieldbyname('YFID').AsString);
      end;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('Update YF_Money_CR Set Money=Price*Qty,BBMoney=Price*Qty*HuiLv');
        sql.Add(' where YFID='''+Trim(YFID)+'''');
        ExecSQL;
      end;
      //Next;
    end;
  end;
  Result:=True;
end;

procedure TfrmDJBCKInPut.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmDJBCKInPut.TBAddClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty=False then
  begin
    CopyAddRowCDS(CDS_Sub);
    with CDS_Sub do
    begin
      Edit;
      FieldByName('SPID').Value:=null;
      FieldByName('PiQty').Value:='0';
      FieldByName('Qty').Value:='0';
      post;
    end;
  end else
  begin
    with CDS_Sub do
    begin
      Append;
      FieldByName('CRTime').Value:=Trim(FormatDateTime('yyyy-MM-dd',Now));
      Post;
    end;
  end;



end;
function TfrmDJBCKInPut.SaveCKData():Boolean;
var
  FCRID,Maxno,FFSPID:string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        {with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_KC where BatchNo='''+Trim(CDS_Sub.fieldbyname('BatchNo').AsString)+'''');
          SQL.Add(' and isnull(CKName,'''')=''纱线'' ');
          Open;
        end;
        if ADOQueryTemp.IsEmpty=False then
        begin
          FCRID:=Trim(ADOQueryTemp.fieldbyname('CRID').AsString);
        end else
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CRID');
            Open;
          end;
          if ADOQueryTemp.IsEmpty then
          begin
            with ADOQueryCmd do
            begin
              Close;
              sql.Clear;
              sql.Add('insert into CK_SXPB_CRID select 0');
              sql.Add(' select * from CK_SXPB_CRID');
              Open;
            end;
            FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
          end else
          begin
            with ADOQueryCmd do
            begin
              Close;
              sql.Clear;
              sql.Add('Update CK_SXPB_CRID Set CRID=CRID+1');
              sql.Add(' select * from CK_SXPB_CRID');
              Open;
            end;
            FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
          end;

          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_KC where CRID='+FCRID);
            Open;
          end;
          with ADOQueryCmd do
          begin
            Append;
            FieldByName('CRID').Value:=FCRID;
            FieldByName('CKName').Value:='纱线';
            FieldByName('BatchNo').Value:=CDS_Sub.fieldbyname('BatchNo').Value;
            FieldByName('SPType').Value:=CDS_Sub.fieldbyname('SPType').Value;
            FieldByName('FactoryName').Value:=CDS_Sub.fieldbyname('FactoryName').Value;
            FieldByName('FactoryNo').Value:=CDS_Sub.fieldbyname('FactoryNo').Value;
            FieldByName('SPName').Value:=CDS_Sub.fieldbyname('SPName').Value;
            FieldByName('SPCF').Value:=CDS_Sub.fieldbyname('SPCF').Value;
            FieldByName('ShaZhi').Value:=CDS_Sub.fieldbyname('ShaZhi').Value;
            FieldByName('SeBie').Value:=CDS_Sub.fieldbyname('SeBie').Value;
            FieldByName('KCNote').Value:=CDS_Sub.fieldbyname('Note').Value;
            Post;
          end;
        end; }
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
          open;
        end;
        FFSPID:=Trim(ADOQueryTemp.fieldbyname('SPID').AsString);
        if Trim(FFSPID)='' then
        begin
          if GetLSNo(ADOQueryCmd,Maxno,'DR','CK_SXPB_CR',3,1)=False then
          begin
            Result:=False;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('取待检布入库编号失败!','提示',0);
            Exit;
          end;
        end else
        begin
          Maxno:=Trim(FFSPID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('delete from YF_Money_CR ');
          sql.Add(' where mainID='''+Trim(Maxno)+'''');
          sql.Add(' and YFName=''客户退货'' ');
          execsql;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(Maxno)+'''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(FFSPID)='' then
          begin
            Append;
          end else
          begin
            Edit;
          end;
          FieldByName('SPID').Value:=Trim(Maxno);
          FieldByName('FZSPID').Value:=Trim(Maxno);
          FieldByName('CKName').Value:='待检布';
          FieldByName('FactoryNo').Value:=Trim(CDS_Sub.fieldbyname('FactoryNo').AsString);
          FieldByName('FromFactoryNo').Value:=Trim(CDS_Sub.fieldbyname('FromFactoryNo').AsString);
          FieldByName('ToFactoryNo').Value:=Trim(CDS_Sub.fieldbyname('ToFactoryNo').AsString);
          FieldByName('ORDMainIdRK').Value:=Trim(CDS_Sub.fieldbyname('ORDMainIdRK').AsString);
          FieldByName('ORDSubIdRK').Value:=Trim(CDS_Sub.fieldbyname('ORDSubIdRK').AsString);
          FieldByName('CRFlag').Value:='入库';
          FieldByName('CRQtyFlag').Value:=1;
//          FieldByName('price').Value:=CDS_Sub.fieldbyname('price').asfloat;
//          FieldByName('money').Value:=cds_sub.fieldbyname('price').AsFloat*cds_sub.fieldbyname('Qty').AsFloat;
          //FieldByName('CRID').Value:=FCRID;
          RTSetSaveDataCDS(ADOQueryCmd,Tv1,CDS_Sub,'CK_SXPB_CR',2);
          if Trim(FFSPID)='' then
            FieldByName('Filler').Value:=Trim(DName)
          else
          begin
            FieldByName('Editer').Value:=Trim(DName);
            FieldByName('EditTime').Value:=SGetServerDate(ADOQueryTemp);
          end;
          if Trim(CDS_Sub.fieldbyname('OrderNo').AsString)<>'' then
          begin
            FieldByName('QCOrderNo').Value:=Trim(CDS_Sub.fieldbyname('OrderNo').AsString);
          end;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(' where SPID='''+Trim(Maxno)+'''');
          ExecSQL;
        end;

//        with ADOQueryCmd do
//        begin
//          Close;
//          sql.Clear;
//          sql.Add('Update YF_Money_CR Set factoryName='''+trim(CDS_Sub.fieldbyname('FactoryName').AsString)+'''');
//          sql.Add(' where mainid='''+Trim(Maxno)+'''');
//          SQL.Add('and CRType=''应付款登记''');
//          ExecSQL;
//        end;

        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(Maxno)+'''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('MXKCQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('入库数小于出库数不能保存!','提示',0);
          Exit;
        end;
        {with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_KC Set KCKGQty=(select sum(isnull(KGQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
          sql.Add(',KCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
          sql.Add(' where CRID='+FCRID);
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_KC where CRID='+Trim(FCRID));
          Open;
        end;
        if ADOQueryTemp.FieldByName('KCKGQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('入库公斤数小于出库公斤数不能保存!','提示',0);
          Exit;
        end;
         }
       { if ADOQueryTemp.FieldByName('KCKeQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('入库颗数小于出库颗数不能保存!','提示',0);
          Exit;
        end; }
        Edit;
        FieldByName('SPID').Value:=Trim(Maxno);
        //FieldByName('CRID').Value:=Trim(FCRID);
        Post;

//        if  CDS_Sub.fieldbyname('crtype').asstring='加工完成' then
//        begin
//          IF not YFData1() then
//          begin
//            ADOQueryCmd.Connection.RollbackTrans;
//            application.MessageBox('生成应付款失败！','提示信息',0);
//          end;
//        end;
//        if CDS_Sub.fieldbyname('crtype').asstring='染色完成' then
//        begin
//          IF not YFData1() then
//          begin
//            ADOQueryCmd.Connection.RollbackTrans;
//            application.MessageBox('生成应付款失败！','提示信息',0);
//          end;
//        end;
//        if CDS_Sub.fieldbyname('crtype').asstring='回修完成' then
//        begin
//          IF not YFData1() then
//          begin
//            ADOQueryCmd.Connection.RollbackTrans;
//            application.MessageBox('生成应付款失败！','提示信息',0);
//          end;
//        end;
//        if CDS_Sub.fieldbyname('crtype').asstring='成品采购入库' then
//        begin
//          IF not YFData1() then
//          begin
//            ADOQueryCmd.Connection.RollbackTrans;
//            application.MessageBox('生成应付款失败！','提示信息',0);
//          end;
//        end;
//
//        if Trim(CDS_Sub.fieldbyname('CRType').AsString)='客户退货' then
//        begin
//         if not YSData(CDS_Sub) then
//         begin
//           ADOQueryCmd.Connection.RollbackTrans;
//           Application.MessageBox('保存异常!','提示',0);
//           exit;
//         end;
//        end;

        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=False;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('保存异常!','提示',0);
  end;

end;

function TfrmDJBCKInPut.YFData1():Boolean;
var
  CRID,OrdMainId,YFID,FComTaiTou,FCRID,FFactoryName:String;
begin
  Result:=False;
  with ADOQueryTemp do
  begin
    Close;
    SQL.Clear;
    sql.Add('select * from YF_Money_KC where FactoryName='+quotedstr(Trim(cds_sub.fieldbyname('factoryName').AsString)));
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    CRID:=ADOQueryTemp.fieldbyname('CRID').AsString;
  end
  else
  begin
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Update YF_Money_CRID set CRID=CRID+1');
      sql.Add('select * from YF_Money_CRID ');
      Open;
    end;
    CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_KC where 1<>1');
      Open;
    end;
    with ADOQueryCmd do
    begin
      Append;
      FieldByName('CRID').Value:=StrToInt(CRID);
      FieldByName('FactoryName').Value:=Trim(cds_sub.fieldbyname('factoryName').AsString);
      FieldByName('ZdyStr1').Value:='应付付';
      Post;
    end;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR where FactoryName='+quotedstr(Trim(cds_sub.fieldbyname('factoryName').AsString)));
    sql.Add(' and mainID='''+Trim(cds_sub.fieldbyname('SPID').AsString)+'''');
 //   sql.Add(' and subID='''+Trim(Order_Sub.fieldbyname('subID').AsString)+'''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty then
  begin
    if GetLSNo(ADOQueryCmd,YFID,'YF','YF_Money_CR',3,1)=False then
    begin
      Application.MessageBox('取坯布应付最大号失败!','提示',0);
      Exit;
    end;
  end
  else
  begin
    YFID:=Trim(ADOQueryTemp.fieldbyname('YFID').AsString);
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR where YFID='''+Trim(YFID)+'''');
    Open;
  end;
  with ADOQueryCmd do
  begin
    if ADOQueryTemp.IsEmpty then
      Append
    else
      Edit;
    FieldByName('YFID').Value:=Trim(YFID);
    FieldByName('YFTypeId').Value:=Trim(cds_sub.fieldbyname('SPID').AsString);
    FieldByName('CRID').Value:=StrToInt(CRID);
    FieldByName('Filler').Value:=Trim(DName);
    FieldByName('CRType').Value:='应付款登记';
    FieldByName('CRFlag').Value:='应付付';
    FieldByName('QtyFlag').Value:=1;
    FieldByName('FactoryName').Value:=Trim(cds_sub.fieldbyname('factoryName').AsString);
    FieldByName('CRTime').Value:=cds_sub.fieldbyname('CRTime').AsDateTime;
    FieldByName('Qty').Value:=cds_sub.fieldbyname('Qty').AsFloat;
    FieldByName('PS').Value:=cds_sub.fieldbyname('PiQty').AsFloat;
    FieldByName('YFType').Value:='自动生成';
    FieldByName('Price').Value:=cds_sub.fieldbyname('price').AsFloat;
    FieldByName('money').Value:=cds_sub.fieldbyname('price').AsFloat*cds_sub.fieldbyname('Qty').AsFloat;
    FieldByName('BBmoney').Value:=cds_sub.fieldbyname('price').AsFloat*cds_sub.fieldbyname('Qty').AsFloat;
    FieldByName('HuiLv').Value:=1;
    FieldByName('BZType').Value:='RMB';
    FieldByName('ComTaiTou').Value:='';
    FieldByName('QtyUnit').Value:=Trim(cds_sub.fieldbyname('QtyUnit').AsString);
    FieldByName('orderNo').Value:=Trim(cds_sub.fieldbyname('OrderNo').AsString);
    FieldByName('P_CodeName').Value:=Trim(cds_sub.fieldbyname('SPName').AsString);
   // FieldByName('P_Color').Value:=Trim(CDS_Main.fieldbyname('QtyUnit').AsString);
    IF Trim(cds_sub.fieldbyname('CRType').AsString)='染色完成' then
      FieldByName('YFName').Value:='染费'
    else
    IF Trim(cds_sub.fieldbyname('CRType').AsString)='采购入库' then
      FieldByName('YFName').Value:='坯布费'
    else
    IF Trim(cds_sub.fieldbyname('CRType').AsString)='成品采购入库' then
      FieldByName('YFName').Value:='成品采购费'
    else
    IF Trim(cds_sub.fieldbyname('CRType').AsString)='回修完成' then
      FieldByName('YFName').Value:='回修费'
    else
    IF Trim(cds_sub.fieldbyname('CRType').AsString)='退货出库' then
      FieldByName('YFName').Value:='退货'
    else
    FieldByName('YFName').Value:='加工费';
    FieldByName('MainId').Value:=Trim(cds_sub.fieldbyname('SPID').AsString);
  //  FieldByName('subId').Value:=Trim(Order_Sub.fieldbyname('subId').AsString);
    FieldByName('status').Value:='0';
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('Update YF_Money_KC Set KCMoney=(select isnull(Sum(Money*QtyFlag),0) from YF_Money_CR A where A.CRID=YF_Money_KC.CRID)');
    sql.Add(',KCBBMoney=(select isnull(Sum(BBMoney*QtyFlag),0) from YF_Money_CR A where A.CRID=YF_Money_KC.CRID)');
    sql.Add(' where CRID='+CRID);
    ExecSQL;
  end;
  Result:=True;
end;

procedure TfrmDJBCKInPut.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('待检布入库登记',Tv1,'待检布仓库');
  Close;
end;

procedure TfrmDJBCKInPut.FormShow(Sender: TObject);
var
  fsj:String;
begin
  ReadCxGrid('待检布入库登记',Tv1,'待检布仓库');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(',OrderNO=(select OrderNO from JYOrder_Main JM where JM.MainId=A.ORDMainIdRK)');
    sql.Add(' ,SOrddefstr1=(select SOrddefstr1 from JYOrder_Sub JM where JM.SubId=A.OrdSubIdRK )');
    sql.Add(' ,PRTColor=(select PRTColor from JYOrder_Sub JM where JM.SubId=A.OrdSubIdRK )');
    sql.Add(' ,PRTHX=(select PRTHX from JYOrder_Sub JM where JM.SubId=A.OrdSubIdRK )');
    sql.Add(' ,PRTkuanNo=(select PRTkuanNo from JYOrder_Sub JM where JM.SubId=A.OrdSubIdRK )');
    sql.Add(' from CK_SXPB_CR A');
    sql.Add(' where SPID='''+Trim(FBCId)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_Sub);
  SInitCDSData20(ADOQueryTemp,CDS_Sub);
  if CDS_Sub.IsEmpty then Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CK_SXPB_CR where FZSPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
    sql.Add(' and CRQtyFlag=-1');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    v1Column4.Options.Focusing:=False;
   // v1Column15.Options.Focusing:=False;
    v1Column13.Options.Focusing:=False;
//    v1Column14.Options.Focusing:=False;
    v2Column1.Options.Focusing:=False;
    v1Column8.Options.Focusing:=False;
    v1Column7.Options.Focusing:=False;
    v1Column1.Options.Focusing:=False;
    v1Column10.Options.Focusing:=False;
    v1Column11.Options.Focusing:=False;

    Exit;
  end else
  begin
    v1Column4.Options.Focusing:=True;
    //v1Column15.Options.Focusing:=True;
    v1Column13.Options.Focusing:=True;
//    v1Column14.Options.Focusing:=True;
    v2Column1.Options.Focusing:=True;
    v1Column8.Options.Focusing:=True;
    v1Column7.Options.Focusing:=True;
    v1Column1.Options.Focusing:=True;
    v1Column10.Options.Focusing:=True;
    v1Column11.Options.Focusing:=True;
  end;
end;

procedure TfrmDJBCKInPut.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString)<>'' then
  begin
    if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty=False then
    begin
      Application.MessageBox('已有出库记录，不能删除!','提示',0);
      Exit;
    end;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!','提示',0);
    end;

  end else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmDJBCKInPut.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if CDS_Sub.Locate('CRTime',null,[])=True then
  begin
    Application.MessageBox('入库时间不能为空!','提示',0);
    Exit;
  end;
//  if CDS_Sub.Locate('CRType',null,[])=True then
//  begin
//    Application.MessageBox('入库类型不能为空!','提示',0);
//    Exit;
//  end;
 { if CDS_Sub.Locate('SPName',null,[])=True then
  begin
    Application.MessageBox('品名不能为空!','提示',0);
    Exit;
  end;}
  if trim(CDS_Sub.fieldbyname('CRType').AsString)<>'期初入库' then
  begin
    if CDS_Sub.Locate('OrderNo',null,[])=True then
    begin
      Application.MessageBox('订单号不能为空!','提示',0);
      Exit;
    end;
  end;
//  if CDS_Sub.Locate('ToFactoryName',null,[])=True then
//  begin
//    Application.MessageBox('存放工厂不能为空!','提示',0);
//    Exit;
//  end;
//  if trim(CDS_Sub.fieldbyname('CRType').AsString)<>'客户退货' then
//  begin
//    if CDS_Sub.Locate('FactoryName',null,[])=True then
//    begin
//      Application.MessageBox('加工厂不能为空!','提示',0);
//      Exit;
//    end;
//  end;
  if CDS_Sub.Locate('PiQty',null,[])=True then
  begin
    Application.MessageBox('匹数不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty',null,[])=True then
  begin
    Application.MessageBox('数量不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('QtyUnit',null,[])=True then
  begin
    Application.MessageBox('数量单位不能为空!','提示',0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType;FromFactoryName',VarArrayOf(['生产退回',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('生产退回的数据，来自工厂不能为空!','提示',0);
    Exit;
  end;
  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!','提示',0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmDJBCKInPut.v1Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='SXKuWei';
      flagname:='库位';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.v1Column14PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
{  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('FactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('FactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          FieldByName('FromFactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('FromFactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
       }
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='CustomerNoName';
      flagname:='客户名称';
      if Trim(DParameters1)<>'高权限' then
        MainType:=Trim(DName);
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('FactoryName').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.v2Column1PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='WJGName';
      flagname:='外加工名称';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('SPName').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.v1Column5PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='KuWei';
      flagname:='库位';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.v1Column11PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
{  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('ToFactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('ToFactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;  }
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='CustomerNoName';
      flagname:='客户名称';
      if Trim(DParameters1)<>'高权限' then
        MainType:=Trim(DName);
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ToFactoryName').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.v1Column16PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('FromFactoryNo').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyCode').AsString) ;
          FieldByName('FromFactoryName').Value:=Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('ZdyName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmDJBCKInPut.v1Column13PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmProductOrderListSel:=TfrmProductOrderListSel.Create(Application);
    with frmProductOrderListSel do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ORDMainIdRK').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('ORDSubIdRK').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('SubId').AsString);
          FieldByName('OrderNo').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('OrderNo').AsString);
          FieldByName('SOrddefstr1').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('SOrddefstr1').AsString);
          FieldByName('PRTColor').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTColor').AsString);
          FieldByName('PRTkuanNo').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTkuanNo').AsString);
          FieldByName('PRTHX').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTHX').AsString);
          FieldByName('SPName').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTCodeName').AsString);
          FieldByName('SPSpec').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTSpec').AsString);
//          FieldByName('SPCF').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTCF').AsString);
          FieldByName('SPMF').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTMF').AsString);
          FieldByName('SPKZ').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTKZ').AsString);
          IF FieldByName('CRType').AsString='客户退货' then
          FieldByName('FactoryName').Value:=Trim(frmProductOrderListSel.Order_Main.fieldbyname('customerNOName').AsString);
          post;
        end;
      end;
    end;
  finally
    frmProductOrderListSel.Free;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmDJBCKInPut.v1Column18PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='KuWei';
      flagname:='库位';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKInPut.ToolButton1Click(Sender: TObject);
begin
  try
    frmProductOrderListSel1:=TfrmProductOrderListSel1.Create(Application);
    with frmProductOrderListSel1 do
    begin
      if ShowModal=1 then
      begin
        Order_Main.DisableControls;
        order_main.First;
        while not Order_Main.Eof do
        begin
          if Order_Main.FieldByName('ssel').AsBoolean then
          begin
            with CDS_Sub do
            begin
              Append;
              FieldByName('CRTime').Value:=Trim(FormatDateTime('yyyy-MM-dd',Now));
              FieldByName('ORDMainIdRK').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('MainId').AsString);
              FieldByName('ORDSubIdRK').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('SubId').AsString);
              FieldByName('OrderNo').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('OrderNo').AsString);
              FieldByName('SOrddefstr1').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('SOrddefstr1').AsString);
              FieldByName('PRTColor').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTColor').AsString);
              FieldByName('PRTkuanNo').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTkuanNo').AsString);
              FieldByName('PRTHX').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTHX').AsString);
              FieldByName('SPName').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTCodeName').AsString);
              FieldByName('SPSpec').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTSpec').AsString);
//              FieldByName('SPCF').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTCF').AsString);
              FieldByName('SPMF').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTMF').AsString);
//              FieldByName('MPRTCode').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('MPRTCode').AsString);
              FieldByName('SPKZ').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('PRTKZ').AsString);
//              FieldByName('FactoryName').Value:=Trim(frmProductOrderListSel1.Order_Main.fieldbyname('ToFactoryName').AsString);
              Post;
            end;
          end;
          Order_Main.Next;
        end;
        Order_Main.EnableControls;
      end;
      Free;
    end;
  finally
    frmProductOrderListSel1.Free;
  end;
end;

procedure TfrmDJBCKInPut.ToolButton2Click(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  OneKeyPost(Tv1,CDS_Sub);
end;

end.
